'-------------------------------------------------------------------------------------------

' : ATMEGA8A    "AVR"    
'  : BASCOM-AVR 2.0.7.1
' : sasha_1973

'-------------------------------------------------------------------------------------------


'---------------------------   -----------------------------------------

 $regfile = "m8def.dat"
 $crystal = 1000000
 $framesize = 32
 $hwstack = 40
 $swstack = 16
 $baud = 4800

'-------------------------------------------------------------------------------
  Config Lcdpin = Pin , Rs = Portb.0 , E = Portb.1 , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5
  Config Lcd = 20 * 4       '  LCD
  Initlcd '  LCD
  Waitms 50       '    
  Cursor Off Noblink       '   
'  Cursor On Noblink         '   
'  Cursor On Blink           '   
  Cls     '  ,   

  Dim _lcd_string As String * 20
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'*****************                                       ***********************
'*****************           I2c         ***********************
'*****************          DS1307        ***********************
'*****************                                       ***********************
'*******************************************************************************
'-------------------------------------------------------------------------------
  Config Sda = Portc.4       '  
  Config Scl = Portc.5       '  
  Config I2cdelay = 5       '  i2c "10 - 100, 5 - 200, 2 - 500, 1 - 1" -         
  I2cinit '  i2c
  Dim _i2c As Byte
'-------------------------------------------------------------------------------
'------------------------------------------------------------------
'|             |  PCF8574,PCF8574N, PCF8575 |  PCF8574A, PCF8574AP |
'|-------------|----------------------------|----------------------|
'|  A0  A1  A2 |       |        |     |    |
'|-------------|-------------|--------------|-----------|----------|
'|  0   0   0  |      &H40   |     &H41     |    &H70   |   &H71   |
'|  1   0   0  |      &H42   |     &H43     |    &H72   |   &H73   |
'|  0   1   0  |      &H44   |     &H45     |    &H74   |   &H75   |
'|  1   1   0  |      &H46   |     &H47     |    &H76   |   &H77   |
'|  0   0   1  |      &H48   |     &H49     |    &H78   |   &H79   |
'|  1   0   1  |      &H4A   |     &H4B     |    &H7A   |   &H7B   |
'|  0   1   1  |      &H4C   |     &H4D     |    &H7C   |   &H7D   |
'|  1   1   1  |      &H4E   |     &H4F     |    &H7E   |   &H7F   |
'------------------------------------------------------------------
'-------------------------------------------------------------------------------

  Const __pcf8574 = &H40
  Const __pcf8574 = &H41

  Const __pcf8574a = &H70
  Const __pcf8574a = &H71

  Const ___pcf8574a = &H72
  Const ___pcf8574a = &H73

'  Const __pcf8575 = &H40
'  Const __pcf8575 = &H41

  Const __pcf8574 = &H42
  Const __pcf8574 = &H43

'  Const __pcf8575 = &H42
'  Const __pcf8575 = &H43

'-------------------------------------------------------------------------------
'-------------------------      PCF8574   -------------------------
'-------------------------------------------------------------------------------
  Const  = &B00000000
  I2csend __pcf8574 , 
'-------------------------------------------------------------------------------
'--------------       PCF8574   -----------------
'-------------------------------------------------------------------------------
  Config Pind.3 = Input       '    
  Set Portd.3
  Config Int1 = Falling       '        Rising ; Falling ; Low Level
  On Int1 _       'Nosave       '>         Ds1307
  Const  = 0       '   (   ""
'-------------------------------------------------------------------------------
'------------------         -------------------
'-------------------------------------------------------------------------------
  Config Portc.0 = Output       '    
   Alias Portc.0       '      
'-------------------------------------------------------------------------------
'--------------------         ----------------------
'-------------------------------------------------------------------------------
  Config Portb.7 = Output       '    
   Alias Portb.7       '      
  Dim _ As Byte
  _ = 30
'-------------------------------------------------------------------------------
'------------------------       --------------------------
'-------------------------------------------------------------------------------

  Defbit _ As Bit       '       
  Dim _ As Byte       '      
  Dim __ As Byte       '       
  Dim __ As Byte       '      ,       
  Dim __ As Byte       '        
  Dim ___ As Byte       '      LCD
  Dim __ As Byte       '       ,       

'-------------------------------------------------------------------------------
  Dim __byte As Byte

  __byte = &B00000001
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  Enable Int1

  Enable Interrupts       '   
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  Do : Nop
'-------------------------------------------------------------------------------
  _:
'-------------------------------------------------------------------------------


    If __ = 1 Then Rcall _

    If ___ = 1 Then Rcall __lcd

    rcall _

Waitms 100
'-------------------------------------------------------------------------------
'-----------------   , ,       ---------------
'-------------------------------------------------------------------------------
'  Idle
'-------------------------------------------------------------------------------
'--------------------------        -----------------------------
'-------------------------------------------------------------------------------
  Goto _
'-------------------------------------------------------------------------------
  Loop : End
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'*************        PCF8574   *************
'*******************************************************************************
'-------------------------------------------------------------------------------
  ___:
'-------------------------------------------------------------------------------
    I2creceive __pcf8574 , __       '     PCF8574A key

    If __ > 0 And __ < 255 Then __ = 1
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'***************       PCF8574   **************
'*******************************************************************************
'-------------------------------------------------------------------------------
  __:
'-------------------------------------------------------------------------------
    I2creceive __pcf8574 , _       '      PCF8574 
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'**************       PCF8574   ***************
'*******************************************************************************
'-------------------------------------------------------------------------------
  __:
'-------------------------------------------------------------------------------
    I2csend __pcf8574 , _       '      PCF8574 
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  _:
'-------------------------------------------------------------------------------
   If __ = 1 Then

       Waitms 

       rCall ___

       Incr __

       If __ > 2 And __ = 255 Then __ = 0

     Else

       __ = 0

      Goto __

   End If
'------------------------------------------------
   rCall __
'------------------------------------------------
      Select Case __
     '------------------------------------------------
       Case Is = 0 : Goto __
     '------------------------------------------------
       Case Is = 255 : Goto __
     '------------------------------------------------
       Case Is = 254 :
     '------------------------------------------------
                       If __ = 1 Then

                           __0 = _.0
                           Toggle __0
                           _.0 = __0

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 253 :
     '------------------------------------------------
                       If __ = 1 Then

                           __1 = _.1
                           Toggle __1
                           _.1 = __1

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 251 :
     '------------------------------------------------
                       If __ = 1 Then

                           __2 = _.2
                           Toggle __2
                           _.2 = __2

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 247 :
     '------------------------------------------------
                       If __ = 1 Then

                           __3 = _.3
                           Toggle __3
                           _.3 = __3

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 239 :
     '------------------------------------------------
                       If __ = 1 Then

                           __4 = _.4
                           Toggle __4
                           _.4 = __4

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 223 :
     '------------------------------------------------
                       If __ = 1 Then

                           __5 = _.5
                           Toggle __5
                           _.5 = __5

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 191 :
     '------------------------------------------------
                       If __ = 1 Then

                           __6 = _.6
                           Toggle __6
                           _.6 = __6

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 127 :
     '------------------------------------------------
                       If __ = 1 Then

                           __7 = _.7
                           Toggle __7
                           _.7 = __7

                           rCall Bip_bip
                         Else
                       End If
'------------------------------------------------
       End Select

       rcall __

       __ = 0
'------------------------------------------------
     __:
       ___ = 1
'------------------------------------------------
    Gifr = 64
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  Bip_bip:
'-------------------------------------------------------------------------------
    Set 

    Waitms _

    Reset 
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'******************        *********************
'*******************************************************************************
'-------------------------------------------------------------------------------
  _:
'-------------------------------------------------------------------------------
    __ = 1

    __ = 1

'    Gifr = 64
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'***********************     LCD  **************************
'*******************************************************************************
'-------------------------------------------------------------------------------
  __lcd:
'-------------------------------------------------------------------------------
    _lcd_string = Str(__)

    _lcd_string = Format(_lcd_string , "  0")

    Locate 1 , 1
    Lcd "Ko o " ; _lcd_string       ' "  "
    Locate 2 , 1
    Lcd "Ko o " ; Hex(__)       ' "  "
    Locate 3 , 1
    Lcd "Ko o " ; Bin(__)       ' "  "
    Locate 4 , 1
    Lcd "Bxo " ; Bin(_)       ' " "
    ___ = 0
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'**********************        *************************
'*******************************************************************************
'-------------------------------------------------------------------------------
  _:
'-------------------------------------------------------------------------------

    Rotate __byte , Left

    I2csend ___pcf8574a , __byte

'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------